Imports System.IO

Public Class PrintUtility

    Declare Function PrintText Lib "SPRT.dll" (ByVal data As String) As Boolean
    Declare Function PrintImage Lib "SPRT.dll" (ByVal serialNo As Integer) As Boolean
    Declare Function PrintBarcode Lib "SPRT.dll" (ByVal type As Integer, ByVal data As String) As Boolean
    Declare Function PortClose Lib "SPRT.dll" () As Boolean
    Declare Function PortOpen Lib "SPRT.dll" (ByVal nPort As Integer) As Boolean
    Declare Function SetFont Lib "SPRT.dll" (ByVal width As Integer, ByVal height As Integer, ByVal underline As Integer, ByVal direction As Integer, ByVal white As Integer) As Boolean
    Declare Function Initialize Lib "SPRT.dll" () As Boolean
    Declare Function ReadData Lib "SPRT.dll" (ByRef data As String) As Integer
    Declare Function SetBarcodeMode Lib "SPRT.dll" (ByVal mode As Integer, ByVal height As Integer, ByVal width As Integer) As Boolean



    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        If cboPort.Text = String.Empty Then
            MsgBox("Please select a port", MsgBoxStyle.Information)
            Return
        End If

        If (PortOpen(Convert.ToInt16(cboPort.Text))) Then
            MsgBox("Connected to COM" & cboPort.Text & " successfully")
            btnPrintText.Enabled = True
            btnPrintImage.Enabled = True
            btnPrintBarcode.Enabled = True

            ' Initalize the printer
            Initialize()
        End If

    End Sub

    Private Sub btnPrintImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintImage.Click
        Try
            ' Print the logo
            MsgBox("Going to print image with serial no = 1. Make sure you have download the image to the printer using the TIII setup tool.", MsgBoxStyle.Information)
            PrintImage(1)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btnPrintText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintText.Click
        Dim fontWidth As Integer
        Dim fontHeight As Integer

        Dim fontUnderline As Integer
        Dim fontDirection As Integer
        Dim fontWhite As Integer

        fontWidth = Convert.ToInt32(cboWidth.SelectedItem.ToString)
        fontHeight = Convert.ToInt32(cboHeight.SelectedItem.ToString)

        If chkUnderline.Checked Then
            fontUnderline = 1
        Else
            fontUnderline = 0
        End If

        If chkDirection.Checked Then
            fontDirection = 1
        Else
            fontDirection = 0
        End If

        If chkWhite.Checked Then
            fontWhite = 1
        Else
            fontWhite = 0
        End If

        ' Set the font
        SetFont(fontWidth, fontHeight, fontUnderline, fontDirection, fontWhite)

        ' Print the text
        PrintText(txtData.Text & ControlChars.CrLf)

        ' Print the file
        Dim stream As StreamReader = Nothing
        Try
            Dim fileName As String = txtFile.Text
            If fileName <> String.Empty Then
                stream = System.IO.File.OpenText(fileName)
                Dim value As String = stream.ReadToEnd
                PrintText(value & ControlChars.CrLf)
            End If
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        Finally
            If Not stream Is Nothing Then
                stream.Close()
                stream = Nothing
            End If
        End Try


    End Sub

    Private Sub PrintUtility_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboPort.SelectedIndex = 0
        cboWidth.SelectedIndex = 0
        cboHeight.SelectedIndex = 0
    End Sub

    Private Sub btnPrintBarcode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintBarcode.Click
        SetBarcodeMode(1, 60, 3)
        Dim barcode As String = "123456789012"
        PrintBarcode(2, barcode)
        barcode = "1234567"
        PrintBarcode(3, barcode)
    End Sub

    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        OpenFileDialog1.InitialDirectory = "\"
        OpenFileDialog1.Filter = "Text files (*.txt)|*.txt|Image Files(*.BMP;*.JPG;*.GIF))|*.BMP;*.JPG;*.GIF"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.FileName = String.Empty
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            txtFile.Text = OpenFileDialog1.FileName
            Dim stream As StreamReader = Nothing
            Try
                Dim fileName As String = txtFile.Text
                If fileName <> String.Empty Then
                    stream = System.IO.File.OpenText(fileName)
                    txtData.Text = stream.ReadToEnd
                End If
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical)
            Finally
                If Not stream Is Nothing Then
                    stream.Close()
                    stream = Nothing
                End If
            End Try
        End If

    End Sub

    Private Sub btnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuit.Click
        Application.Exit()
    End Sub
End Class
